/* OpenDoors 6.00
 * (C) Copyright 1991 - 1996 by Brian Pirie. All Rights Reserved.
 *
 *
 *        File: ODTypes.c
 *
 * Description: Defines special data types used by OpenDoors.
 *
 *   Revisions: Date          Ver   Who  Change
 *              ---------------------------------------------------------------
 *              Oct 15, 1994  5.10  BP   Created.
 *              Jan 30, 1996  5.10  BP   Added kODRCTimeout.
 *              Feb 08, 1996  5.10  BP   Added kODRCSafeFailure.
 *              Feb 08, 1996  5.10  BP   Added kODRCUnrecoverableFailure.
 *              Feb 19, 1996  6.00  BP   Changed version number to 6.00.
 */

#ifndef _INC_ODTYPES
#define _INC_ODTYPES

/* Generic handle data type. */
typedef void * tODHandle;
#define ODHANDLE2PTR(h, t) ((t *) h)
#define ODPTR2HANDLE(p, t) ((tODHandle) p)

/* OpenDoors function call result codes. */
typedef enum
{
   kODRCSuccess,
   kODRCGeneralFailure,
   kODRCNoMemory,
   kODRCNothingWaiting,
   kODRCNoMatch,
   kODRCEndOfFile,
   kODRCNoPortAddress,
   kODRCNoUART,
   kODRCInvalidCall,
   kODRCFileAccessError,
   kODRCFilenameTooLong,
   kODRCTimeout,
   kODRCSafeFailure,
   kODRCUnrecoverableFailure,
} tODResult;

/* Callback function types. */
#ifdef _MSC_VER
typedef void ODCALL OD_COMPONENT_CALLBACK(void);
typedef void ODCALL OD_PERSONALITY_CALLBACK(BYTE btOperation);
#else /* !_MSC_VER */
typedef void OD_COMPONENT_CALLBACK(void);
typedef void OD_PERSONALITY_CALLBACK(BYTE btOperation);
#endif /* !_MSC_VER */

#endif /* !_INC_ODTYPES */
