/* OpenDoors 6.00
 * (C) Copyright 1991 - 1996 by Brian Pirie. All Rights Reserved.
 *
 *
 *        File: ODUtil.h
 *
 * Description: Contains prototypes and definitions for use by non-platform
 *              specific utility functions. These functions are implemented in
 *              odutil.c. Platform-specific utility functions are defined in
 *              odplat.h, and implemented in odplat.c.
 *
 *   Revisions: Date          Ver   Who  Change
 *              ---------------------------------------------------------------
 *              Nov 01, 1994  5.10  BP   Created.
 *              Dec 31, 1994  5.10  BP   Added ODMakeFilename().
 *              Nov 13, 1995  5.10  BP   32-bit portability.
 *              Nov 23, 1995  5.10  BP   Added ODDWordDivide().
 *              Nov 23, 1995  5.10  BP   Added ODDStringHasTail().
 *              Nov 23, 1995  5.10  BP   Added ODFileSize().
 *              Feb 19, 1996  6.00  BP   Changed version number to 6.00.
 */

#ifndef _INC_ODUTIL
#define _INC_ODUTIL

#include "ODGen.h"
#include "ODTypes.h"
#include "OpenDoor.h"

/* General string manipulation functions. */
void ODStringCopy(char *pszDest, CONST char *pszSource, INT nSizeofDest);
char *ODStringCToPascal(char *psPascalString, BYTE btMaxPascalLength,
   char *pszCString);
char *ODStringPascalToC(char *pszCString, char *psPascalString,
   BYTE btMaxLength);
BOOL ODStringHasTail(char *pszFullString, char *pszTail);

/* File-related functions. */
tODResult ODMakeFilename(char *pszOut, CONST char *pszPath,
   CONST char *pszFilename, INT nMaxOutSize);
DWORD ODFileSize(FILE *pfFile);

/* DWORD math functions. */
DWORD ODDWordShiftLeft(DWORD dwValue, BYTE btDistance);
DWORD ODDWordShiftRight(DWORD dwValue, BYTE btDistance);
BOOL ODDWordDivide(DWORD *pdwQuotient, DWORD *pdwRemainder,
   DWORD dwDividend, DWORD dwDivisor);

#endif /* !_INC_ODUTIL */
